﻿namespace SinMaiLauncher.Models;

internal class SinMaiLauncherSettingModel
{
    public RectModel AutoRect { get; set; }

    public InfraSettings Infra { get; set; }

    public class InfraSettings
    {
        public string InfraPath { get; set; }

        public MariaDbSettings MariaDb { get; set; }
        public AquaDxSettings AquaDx { get; set; }

        public class MariaDbSettings
        {
            public string WorkingDir { get; set; }
            public string MySqlServerExe { get; set; }
            public string MySqlServerArgs { get; set; }
            public string Host { get; set; }
            public int Port { get; set; }
            public string Usr { get; set; }
            public string Pwd { get; set; }
        }

        public class AquaDxSettings
        {
            public string WorkingDir { get; set; }
            public string JavaPath { get; set; }
            public string JavaArgs { get; set; }
            public string Host { get; set; }
            public int Port { get; set; }
        }
    }

    public SinMaiSettings SinMai { get; set; }

    public class SinMaiSettings
    {
        public string WorkingDir { get; set; }

        public string InjectExe { get; set; }
        public string InjectArgs { get; set; }

        public string SinMaiExe { get; set; }
        public string SinMaiArgs { get; set; }

        public string AimeFileDir { get; set; }
        public string AimeFileName { get; set; }
    }

    public class RectModel
    {
        public int Left { get; set; }
        public int Top { get; set; }
        public int Width { get; set; }
        public int Height { get; set; }
    }
}